#python3 -m pip install -r /home/gcp/tests/mejor_gestion/requirements.txt
#se requiere recibir por argumentos los parametros:
#fecha YMD, empresa, idcliente, idsegmento, idasignacion
 
from config.conexiones import *
from funciones_genericas import *

r = redis.Redis()

begin = inicio_ejecucion('BEGIN')
r.set(name='bestManagement360',value='running')
r.set(name='bestManagement360Log1',value=str(begin))
# r.get(name='bestManagement360')
#Como se desea configurar, por defecto o por argumentos
settingsBy = 'args'

# enterprise = 'enterprise'
enterprise = 'Falabella'
server = 'localhost'
dbEnterprise = 'falabella'
################################
if settingsBy == 'args':
    if(len(sys.argv) >= 8):
        argsEnterprise = str(sys.argv[2])#.replace('avi_reportes_','')
        # argsEnterprise = sys.argv[3]
        dbEnterprise=argsEnterprise
################################

engine = conexiones(return_con=True,servidor=server)
engine_strauss = engine
json_con = conexiones( servidor=server,bd='avi_reportes_'+dbEnterprise,return_jsondb=True )

bd_avi_360 = conexiones(servidor=server,bd='avi_reportes_'+dbEnterprise)
bd_principal_avi = bd_avi_360.replace('_reportes','')
bd_strauss_360 = 'strauss_2_dev'
tabla_avi_360 = 'reportes_gestion_total_360_TEMP'
# tabla_avi_360 = 'reportes_gestion_total_360_MTD'
tabla_strauss_360 = 'TMP_EXT_360_STRAUSS'
tabla_homologaciones_360 = 'homologaciones'

id_clientes = [3]
id_clientes_st = [122]
id_segmentos = [0]
id_segmentos_st = [0]
idsAsignacion = ''
condicional_query = " AND idresultado != '0'"
hasFindAviOld = True
hasFindStrauss = False
isBestManaged = True
isTotalManaged = True
isDownloadableLastBM = 0
isReplaceTables = 1

keysBM = ['Identificacion', 'producto1']
keyIdresultadoHomologations = 'idresultado'
keyIdresultado360 = 'idresultado'
keyRanking = 'ranking_cliente'
keyIdSegmento = 'id_segmento'
keyIdCliente = 'id_cliente'
listIdsExcluded = ['118','119','316','315','40315','309','318','313','0','317','312']
listColumnsDownloadable = ['telefono','ext','intento','Identificacion','ID_CAMPANA','Nombre','fecha_llamada','f5','hora_llamada','hora_contestacion','hora_fin_llamada','estado','idresultado','fecha1','fecha2','valor1','valor2','token','url','id_asignacion','producto1','empresa','canal','id_cliente','id_segmento','indicador_frustracion','observacion','cliente','homologacion_intelibpo','homologacion_cliente','tipo_contacto_intelibpo','tipo_contacto_cliente','efectividad_intelibpo','efectividad_cliente','gestionados_intelibpo','gestionados_cliente','ranking_cliente','last_management','last_mockup','moment','previous_moment','count_moment','try_by_id','try_by_phone','count_promises']
listIdsPromises = ['165','168']
hoursColumns = ['hora_llamada','hora_contestacion','hora_fin_llamada']

tableBMToday = 'best_management_360_today'
tableBMTotal = 'best_management_360'
tableBMMonth = 'best_management_360_month'
tableBMLast = 'best_management_360_last'
tableMMoments = 'management_total_360_moments'
localServerName = 'localhost'
localDataBaseName = '360'
localTableName = 'tables'
localTableType = 'best_management'
tableName360BM = 'best_management_360'

dayNumber = 0
dateToday = (date.today() - timedelta(dayNumber)).strftime("%Y-%m-%d")
dateYesterdayFile = (date.today() - timedelta(1)).strftime("%y%m%d")
dateTodayFile = (date.today() - timedelta(dayNumber)).strftime("%Y%m%d")
dateDay1 = (date.today() - timedelta(dayNumber)).strftime("%Y-%m-01")
yearNow = (date.today() - timedelta(dayNumber)).strftime("%Y")
monthNow = (date.today() - timedelta(dayNumber)).strftime("%m")

if settingsBy == 'args':
    if(len(sys.argv) >= 8):
        print('sys.argv',sys.argv)
        argsDate = sys.argv[1]
        argsIdCliente = sys.argv[3]
        argsIdSegmento = sys.argv[4]
        argsIdAsignacion = sys.argv[5]
        isDownloadableLastBM = int(sys.argv[6])
        isReplaceTables = int(sys.argv[7])
#         keysBM = sys.argv[8].split(',')
        # argsDBName = 'falabella'
        # argsDate = '20201028'
        # argsEnterprise = 'FALABELLA'
        # argsIdCliente = '3'
        # argsIdSegmento = '5'
        # argsIdAsignacion = '11,12'
        
        dateToday = datetime.strptime(argsDate, '%Y%m%d').strftime('%Y-%m-%d')
        
        enterprise = argsEnterprise
        id_clientes = argsIdCliente.split(',')
        id_segmentos = argsIdSegmento.split(',')
        idsAsignacion = argsIdAsignacion.split(',')

        print("El nombre del programa es " + sys.argv[0])
        print("El sys.argv[1] es " + sys.argv[1])
        print("El sys.argv[2] es " + sys.argv[2])
    else:
        print("No se enviaron los 5 parametros esperados")
        sys.exit();

if isReplaceTables: ifExistsTables = 'replace'
else: ifExistsTables = 'append'
monthNow = datetime.strptime(dateToday, "%Y-%m-%d").strftime("%m")

# print(argsDBName)
# print(argsDate)
# print(argsEnterprise)
# print(argsIdCliente)
# print(argsIdSegmento)
# print(argsIdAsignacion )
# sys.exit();
# fecha1, fecha2 = dateDay1, dateToday
idCliente = str(id_clientes).replace('[','').replace(']','')
idSegmento = str(id_segmentos).replace('[','').replace(']','')
idAsignacion = str(idsAsignacion).replace('[','').replace(']','')

fecha1, fecha2 = dateToday, dateToday
#validateAndCreateFolder
pathDownloadable = '/home/sftpserver/reports/'+dbEnterprise+'/'
fileNameDownloadable = "best_management_360_last_{0}_{1}_{2}_{3}_{4}.xlsx".format(dbEnterprise,argsIdCliente,argsIdSegmento,argsIdAsignacion,dateTodayFile)
pathMain = """/home/sftpserver/falabella/"""
fileNameBM = """Reporte_CLIENTE_SEGMENTO_MejorGestion_Acumulada_{0}.xlsx""".format(dateTodayFile)
fileNameTM = """Reporte_CLIENTE_SEGMENTO_GestionTotal_Acumulada_{0}.csv""".format(dateTodayFile)
# fileNameOutput = pathMain + fileName
path_files = []

operationsAreaEmails = ['jherrera@intelibpo.com','yruiz@intelibpo.com']
bossesAreaEmails = ['saponte@intelibpo.com']
developmentAreaEmails = ['jmosquera@intelibpo.com']
sendersList = [','.join(operationsAreaEmails),','.join(bossesAreaEmails),','.join(developmentAreaEmails)]
senders = ','.join(sendersList)
senders = 'jmosquera@intelibpo.com'
mailTitle = """: Reporte TIPO_GESTION, del {0} al {1}""".format(fecha1,fecha2)
mailBody = """Buenos dias,
            <br>
           Adjunto se encuentra el Reporte del {0} al {1}
           """.format(fecha1,fecha2)

sheetNameBM = 'GestionTotal'
sheetNameTM = 'MejorGestion'

columnsToRemove = []
columnsToRemoveTmp = []

listNotDelete = []
for i in range(5): listNotDelete.append((date.today() - timedelta(i)).strftime("%Y%m%d"));
print(listNotDelete)


localEngine = conexiones(return_con=True,servidor=localServerName)
localConnection = conexiones( servidor=localServerName,bd=localDataBaseName,return_jsondb=True )
q = """SELECT a.name,b.query,a.truncate, a.delete FROM `{0}`.{1} AS a
    JOIN `{0}`.queries AS b ON a.id_queries = b.id""".format(localDataBaseName,localTableName,localTableType)
localTableNameTruncate = localTableNameDelete = 'queries'
localTableTypeTruncate = 'truncate'
localTableTypeDelete = 'delete'
q_truncate = """SELECT b.query as name,b.query FROM `{0}`.{1} AS b WHERE b.type = '{2}' """.format(localDataBaseName,localTableNameTruncate,localTableTypeTruncate)
q_delete = """SELECT b.query as name,b.query FROM `{0}`.{1} AS b WHERE b.type = '{2}' """.format(localDataBaseName,localTableNameDelete,localTableTypeDelete)

dfTables = consultar_tabla(q,localEngine)
dfTablesTruncate = consultar_tabla(q_truncate,localEngine)
dfTablesDelete = consultar_tabla(q_delete,localEngine)
dfTables

keyFieldBM = 'fecha_llamada'
valueField = dateToday
bmDeleteConditions = [ " fecha_llamada = '{0}' ".format(dateToday),"id_cliente = {0}".format(idCliente),"id_segmento IN ({0}) ".format(idSegmento)," id_asignacion IN ({0}) ".format(idAsignacion) ]

if len(bmDeleteConditions) > 0:
    bmDeleteCondition = 'WHERE'
    for condition in bmDeleteConditions:
        bmDeleteCondition += condition 
        if int(bmDeleteConditions.index(condition))+1 != len(bmDeleteConditions): bmDeleteCondition += ' AND ' 
print(bmDeleteCondition)

params = {}
for key in keysBM:
    params[key] = 'object'

for index, row in dfTables.iterrows():
    print(row['name'])
    if not validar_tabla(tablename=row['name'],json=json_con) or row['truncate'] or row['delete']:
        print('No existe y se creara o existe y se truncara', row['name'])
        connection = mysqlConnection(row['name'],json=json_con)
        cursor = connection.cursor()
        if not validar_tabla(tablename=row['name'],json=json_con):
            queryTmp = row['query'].replace('database_name',bd_avi_360).replace('table_name',row['name']).replace('\r\n','')
            print('queryTmp',queryTmp)
        else:
            if row['truncate']:
                for index, row2 in dfTablesTruncate.iterrows():
                    queryTmp = row2['query'].replace('database_name',bd_avi_360).replace('table_name',row['name']).replace('\r\n','')
                print('queryTmp',queryTmp)
            if row['delete']:
                for index, row3 in dfTablesDelete.iterrows():
                    queryTmp = row3['query'].replace('database_name',bd_avi_360).replace('table_name',row['name']).replace('\r\n','') + bmDeleteCondition #.replace('key_field',keyFieldBM).replace('value_field',valueField)
                print('queryTmppppppppp',queryTmp)
        if int(row['truncate']) or int(row['delete']):
            for query in queryTmp.split(';'):
                cursor.execute(query)
    #             print('cursor',cursor)
                #NOTA: AQUI FALTA HACER OTRO QUERY PARA VALIDAR SI EXISTE LA TABLA CREADA
                print('Se ha escrito SQL: ' + str(row['name']),cursor );    
                print('query',query)
        if (connection.is_connected()):
            connection.commit()
            cursor.close()
            connection.close()
            connection.disconnect() 

print('LOG: INICIO ELIMINACION DE ARCHIVOS EN CARPETA DE CLIENTE')
for file in os.listdir(pathDownloadable):
    if file[-13:-5] not in (listNotDelete):
        os.remove(pathDownloadable+file)
        print('LOG: Removido',pathDownloadable+file)
print('LOG: FIN ELIMINACION DE ARCHIVOS EN CARPETA DE CLIENTE')

# columnsSql360
queryColumnsSql360 = """SELECT * FROM {0}.{1} LIMIT 0""".format(bd_avi_360,tableName360BM)
columnsSql360 = pd.read_sql(queryColumnsSql360,engine).columns.values[1:]
queryColumnsSql360Moments = """SELECT * FROM {0}.{1} LIMIT 0""".format(bd_avi_360,tableMMoments)
columnsSql360Moments = pd.read_sql(queryColumnsSql360Moments,engine).columns.values[1:]

###### # PRIMERO, seteo por default en 0 los ids para búsqueda
id_clientes_toquery=id_clientes_st_toquery=id_segmentos_toquery=id_segmentos_st_toquery=idsAsignacionToQuery = ''
condicional_id_clientes,condicional_id_clientes_st,condicional_id_segmentos,condicional_id_segmentos_st = '','','',''

# if settingsBy == 'args' :
#     id_clientes = argsIdCliente;
#     id_segmentos = argsIdSegmento;

# SEGUNDO, valido si en los parametros de id_clientes vino vacio o no, para darle lo q traiga, sino queda en el default
if( len( id_clientes ) >0 ) and ( 0 not in id_clientes ):
    id_clientes_toquery = ','.join([str(elem) for elem in id_clientes])
    condicional_id_clientes = """   WHERE id IN ({0})""".format(id_clientes_toquery)
if( len( id_clientes_st ) >0 ) and ( 0 not in id_clientes_st ):
    id_clientes_st_toquery = ','.join([str(elem) for elem in id_clientes_st])
    condicional_id_clientes_st = """   WHERE id IN ({0})""".format(id_clientes_st_toquery)
if( len( id_segmentos ) >0 ) and ( 0 not in id_segmentos ):
    id_segmentos_toquery = ','.join([str(elem) for elem in id_segmentos])
    condicional_id_segmentos = """   WHERE id IN ({0})""".format(id_segmentos_toquery)
if( len( id_segmentos_st ) >0 ) and ( 0 not in id_segmentos_st ):
    id_segmentos_st_toquery = ','.join([str(elem) for elem in id_segmentos_st])
    condicional_id_segmentos_st = """   WHERE id IN ({0})""".format(id_segmentos_st_toquery)
if( len( idsAsignacion ) >0 ) and ( 0 not in idsAsignacion ):
    idsAsignacionToQuery = ','.join([str(elem) for elem in idsAsignacion])
    ifIdsAsignacion = """ AND id_asignacion IN ({0})""".format(idsAsignacionToQuery)



# Queries
q_clientes ="""SELECT id AS id_cliente,nombre, 'AVI' AS "FUENTE" FROM {0}.Clientes {1}""".format(bd_principal_avi,condicional_id_clientes)
q_clientes_st ="""SELECT id AS id_cliente, name AS nombre, 'STRAUSS' AS "FUENTE" FROM {0}."Clients" {1}""".format(bd_strauss_360,condicional_id_clientes_st)
q_segmentos ="""SELECT id,nombre,id_cliente, 'AVI' AS "FUENTE" FROM {0}.Segmentos {1}""".format(bd_principal_avi,condicional_id_segmentos)
q_segmentos_st ="""SELECT id,name AS nombre, client_id as id_cliente, 'STRAUSS' AS "FUENTE" FROM {0}."Segments"  {1}""".format(bd_strauss_360,condicional_id_segmentos_st)
q_asignaciones ="""SELECT id_asignacion,id_segmento, 'AVI' AS "FUENTE" FROM {0}.asignacion {1} {2}""".format(bd_principal_avi,condicional_id_segmentos.replace('id',keyIdSegmento),ifIdsAsignacion)
q_asignaciones_st ="""SELECT id AS id_asignacion,"segmentId" AS id_segmento, 'STRAUSS' AS "FUENTE" FROM {0}."Assignments" {1}""".format(bd_strauss_360,condicional_id_segmentos_st.replace('id','"segmentId"'))
q_bases ="""SELECT id AS id_base,nombre,id_cliente,id_segmento,id_asignacion, 'AVI' AS "FUENTE" FROM {0}.Bases""".format(bd_principal_avi)
q_bases_st ="""SELECT id AS id_base, name AS nombre,clientId AS id_cliente,segmentId AS id_segmento,assignmentId AS id_asignacion, 'STRAUSS' AS "FUENTE" FROM {0}."Bases" """.format(bd_strauss_360)
q_campanas ="""SELECT ID_CAMPANA, Nombre_campana AS nombre, Cliente as cliente, idsegmento AS id_segmento, id_asignacion,idbase,'AVI' AS FUENTE
    FROM {0}.Campanas""".format(bd_principal_avi)
q_campanas_st ="""SELECT "campaignId" AS "ID_CAMPANA",'' AS nombre,"clientId" as cliente,"segmentId" AS "id_segmento","assignmentId" AS "id_asignacion","baseId" AS idbase,'STRAUSS' AS "FUENTE"
    FROM {0}."CampaignsDetails" """.format(bd_strauss_360)


q_360="""
SELECT 
    a.telefono, a.ext, a.intento, a.Identificacion, a.ID_CAMPANA,
    a.Nombre, a.fecha_llamada, a.f5, a.hora_llamada,
    a.hora_contestacion, a.hora_fin_llamada, a.estado, a.verificacion,
    a.tel_ok, a.comunicar, a.conoce_a, a.dejar_msg, a.grabacion,
    a.resultado, a.idresultado, a.fecha1, a.fecha2, a.valor1, a.valor2,
    a.asesor, a.dias_mora, a.email, a.direccion, a.token, a.url,
    a.id_asignacion, a.v1, a.v2, a.v3, a.v4, a.v5, a.v6, a.v7, a.v8,
    a.v9, a.v10, a.v11, a.v12, a.v13, a.v14, a.v15, a.v16, a.v17,
    a.v18, a.v19, a.v20, a.v21, a.v22, a.v23, a.v24, a.v25, a.v26,
    a.v27, a.v28, a.v29, a.v30, a.producto1, a.saldo_capital1,
    a.producto2, a.saldo_capital2, a.producto3, a.saldo_capital3,
    a.producto4, a.saldo_capital4, a.producto5, a.saldo_capital5,
    a.producto6, a.saldo_capital6, a.producto7, a.saldo_capital7,
    a.producto8, a.saldo_capital8, a.producto9, a.saldo_capital9,
    a.producto10, a.saldo_capital10, a.producto11, a.saldo_capital11,
    a.producto12, a.saldo_capital12, a.producto13, a.saldo_capital13,
    a.producto14, a.saldo_capital14, a.producto15, a.saldo_capital15,
    a.producto16, a.saldo_capital16, a.producto17, a.saldo_capital17,
    a.producto18, a.saldo_capital18, a.producto19, a.saldo_capital19,
    a.producto20, a.saldo_capital20, a.producto21, a.saldo_capital21,
    a.producto22, a.saldo_capital22, a.producto23, a.saldo_capital23,
    a.producto24, a.saldo_capital24, a.producto25, a.saldo_capital25,
    a.empresa, a.canal, c.id AS "id_cliente", s.id AS "id_segmento",
    a.indicador_frustracion, a.observacion, c.nombre AS "cliente",
    s.nombre AS "segmento" 
FROM
    {0}.{1} AS a
JOIN {5}.Clientes AS c
    ON a.id_cliente = c.nombre
JOIN {5}.Segmentos AS s
    ON a.id_segmento = s.nombre
WHERE
    a.fecha_llamada BETWEEN '{2}' AND '{3}'
    AND a.Identificacion NOT LIKE '%%PR%%'
    AND a.Identificacion NOT LIKE '%%Pr%%'
    AND a.Identificacion NOT LIKE '%%pr%%'
    {4}
""".format(bd_avi_360,tabla_avi_360,fecha1,fecha2,condicional_query,bd_avi_360.replace('reportes_',''))
q_homologaciones="""
SELECT
    homologacion_intelibpo,
    homologacion_cliente,
    tipo_contacto_intelibpo,
    tipo_contacto_cliente,
    efectividad_intelibpo,
    efectividad_cliente,
    gestionados_intelibpo,
    gestionados_cliente,
    ranking_cliente,
    idresultado_intelibpo AS idresultado,
    idsegmento AS id_segmento,
    idcliente AS id_cliente
FROM
    {0}.{1}
""".format(bd_avi_360,tabla_homologaciones_360)

q360BMTotal = "SELECT * FROM {0}.{1} WHERE EXTRACT(MONTH FROM {2}) = '{3}' AND id_cliente = {4} AND id_segmento IN ({5}) AND id_asignacion IN ({6})".format(bd_avi_360,tableBMTotal,keyFieldBM,monthNow,idCliente,idSegmento,idAsignacion)

# q360BMLastDates = "SELECT DISTINCT fecha_llamada FROM {0}.{1} {2}".format(bd_avi_360,tableBMTotal,bmDeleteCondition)
q360BMLastDates = "SELECT DISTINCT fecha_llamada FROM {0}.{1} WHERE id_cliente = {2} AND id_segmento IN ({3}) AND id_asignacion IN ({4})".format(bd_avi_360,tableBMTotal,idCliente,idSegmento,idAsignacion)
#q360BMLast = "SELECT * FROM {0}.{1} WHERE EXTRACT(MONTH FROM {2}) = '{3}' AND id_cliente = {4} AND id_segmento = {5} AND id_asignacion IN ({6})".format(bd_avi_360,tableBMTotal,keyFieldBM,monthNow,idCliente,idSegmento,idAsignacion)
q360BMLast = "SELECT * FROM {0}.{1} WHERE id_cliente = {2} AND id_segmento IN ({3}) AND id_asignacion IN ({4})".format(bd_avi_360,tableBMTotal,idCliente,idSegmento,idAsignacion)
q360BMLastDefault = q360BMLast
q360BMLast

#########################################################################################################
df_clientes = df_segmentos = df_asignaciones = df_360 =  pd.DataFrame()
if hasFindAviOld:
    df_clientes = consultar_tabla(q_clientes,engine)
    df_segmentos = consultar_tabla(q_segmentos,engine)
    df_asignaciones = consultar_tabla(q_asignaciones,engine)
if hasFindStrauss:
    df_clientes_st = consultar_tabla(q_clientes_st,engine_strauss)
    df_segmentos_st = consultar_tabla(q_segmentos_st,engine_strauss)
    df_asignaciones_st = consultar_tabla(q_asignaciones_st,engine_strauss)
    
    print(' len(df_clientes) before', len(df_clientes) )
    df_clientes = df_clientes.append(df_clientes_st)
    print(' len(df_clientes) after', len(df_clientes) )
    print(' len(df_segmentos) before', len(df_segmentos) )
    df_segmentos = df_segmentos.append(df_segmentos_st)
    print(' len(df_segmentos) after', len(df_segmentos) )
    print(' len(df_asignaciones) before', len(df_asignaciones) )
    df_asignaciones = df_asignaciones.append(df_asignaciones_st)
    print(' len(df_asignaciones) after', len(df_asignaciones) )
print('df_clientes',df_clientes)
print('df_segmentos',df_segmentos)
print('df_asignaciones',df_asignaciones)

if len(df_clientes) == 0: print('LOG: No hay registros en df_asignaciones');r.set(name='bestManagement',value='error df_clientes=0');sys.exit()
if len(df_segmentos) == 0: print('LOG: No hay registros en df_segmentos');r.set(name='bestManagement',value='error df_segmentos=0');sys.exit()
if len(df_asignaciones) == 0: print('LOG: No hay registros en df_asignaciones');r.set(name='bestManagement',value='error df_asignaciones=0');sys.exit()

print('q_asignaciones',q_asignaciones)

print('************ REPORTING BEGIN ************')

for index, row_c in df_clientes.iterrows():
    id_cliente, cliente, fuente = row_c[keyIdCliente], row_c['nombre'], row_c['FUENTE']
    print('EN CURSO ID_CLIENTE: '+  str(id_cliente) + ' FUENTE: ' + fuente)
    for index, row in df_segmentos[(df_segmentos.FUENTE == fuente) & (df_segmentos.id_cliente.astype(int) == int(id_cliente))].iterrows():
        id_segmento,segmento = row['id'], row['nombre']
        print( ' ID_SEGMENTO: ' + str(id_segmento) + ' => SEGMENTO: ' + str(segmento) )
        listado_asignaciones = df_asignaciones[df_asignaciones.id_segmento == int(id_segmento)]['id_asignacion'].values.tolist()
        listado_asignaciones =  "'" + "','".join((map(str,listado_asignaciones))) + "'"
        condicional_asignaciones = """   AND a.id_asignacion IN ({0})""".format(listado_asignaciones)
        condicional_segmento_360_avi = """   AND a.id_segmento = '{0}'""".format(segmento)
        condicional_segmento_360_st = """   AND a.id_segmento = '{0}' """.format(id_segmento)
        query = (q_360 if fuente == 'AVI' else q_360_st)
        eng   = (engine if fuente == 'AVI' else engine_strauss)
        condicional_segmento = (condicional_segmento_360_avi if fuente == 'AVI' else condicional_segmento_360_st)
        q_360_final = query + condicional_asignaciones + condicional_segmento
        df_360 = df_360.append(consultar_tabla(q_360_final,eng,chunk_size=1000000,params=params))
        print('len(df_360) BEFORE drop_duplicates',len(df_360))
        df_360 = df_360.drop_duplicates()
        print('len(df_360) AFTER drop_duplicates',len(df_360))

if not len(df_360) : print('LOG: No hay registros en df_360');#sys.exit()
else: 
    if not validar_tabla('homologaciones',json_con): print('LOG: No existe la tabla de homologaciones');#sys.exit()
    df_h = consultar_tabla(q_homologaciones,engine)

    if not len(df_h) : print('LOG: No existen registros la tabla de homologaciones');#sys.exit()
    else:
        df_360[keyIdresultado360] = df_360[keyIdresultado360].astype(str).str.strip()
        df_360[keyIdSegmento] = df_360[keyIdSegmento].astype(str).str.strip()
        df_360 [keyIdCliente] = df_360 [keyIdCliente].astype(str).str.strip()
        df_h [keyIdresultadoHomologations] = df_h [keyIdresultadoHomologations].astype(str).str.strip()
        df_h [keyIdSegmento] = df_h [keyIdSegmento].astype(str).str.strip()
        df_h [keyIdCliente] = df_h [keyIdCliente].astype(str).str.strip()
        df_h [keyRanking] = df_h [keyRanking].astype(int)

        print('df_360 before:',len(df_360))
        df_360 = pd.merge( df_360,df_h, how='inner',
                      left_on=[keyIdresultado360,keyIdSegmento,keyIdCliente],
                      right_on=[keyIdresultadoHomologations,keyIdSegmento,keyIdCliente]
                    ).sort_values(keyRanking)
        print('df_360 after:',len(df_360))
        if not len(df_360) : print('LOG: No hay registros en la tabla de homologaciones para el segmento')

    df_360['count_moment'] = 0
    df_360['moment'] = df_360['v13']
    df_360['previous_moment'] = df_360['v11']
    df_360['last_mockup'] = ''

    for key in keysBM:
        df_360[key] = df_360[key].astype(str).str.strip()
    if ('last_management' in  df_360.columns.values): del df_360['last_management'];
    df_ultima_gestion = df_360.sort_values(['fecha_llamada','hora_llamada'],ascending=False)\
            .groupby(keysBM).head(1)\
            [['homologacion_intelibpo'] + keysBM]\
            .rename(columns={'homologacion_intelibpo':'last_management'})
    print('len(df_360)',len(df_360))
    print('len(df_ultima_gestion)',len(df_ultima_gestion))
    
    for key in keysBM:
        df_ultima_gestion[key] = df_ultima_gestion[key].astype(str).str.strip()
        
    df_360 = pd.merge( df_360, df_ultima_gestion,
            how='left', on=keysBM)

    df_360['last_management'].fillna('N/A',inplace=True)
    ######################################################################################################
    print('LOG: BEGIN Tratando fecha y horas llamada')
    for column in ['hora_llamada','hora_contestacion','hora_fin_llamada']:
        if (column in  df_360.columns.values):
            df_360[column] = df_360[column].astype(str).str.split().str[-1].str.rsplit('.').str[0]
    column = 'fecha_llamada'
    if (column in df_360.columns.values):
        df_360[column] = pd.to_datetime(df_360[column], format='%Y-%m-%d', errors='coerce')
    column = 'f5'
    if (column in df_360.columns.values):
        df_360[column] = pd.to_datetime(df_360[column].astype(str).str[:10], format='%Y-%m-%d', errors='coerce')
    print('LOG: END Tratando fecha y horas llamada')
    ################################################################################################################
    print('LOG:BEGIN try_by_phone')
    if not len(df_360[~df_360[keyIdresultado360].astype(str).str.strip().isin(listIdsExcluded)]): df_360['try_by_phone'] = 0
    else: 
        df_intentos = (df_360[~df_360[keyIdresultado360].astype(str).str.strip().isin(listIdsExcluded)]
                       .groupby(df_360[~df_360[keyIdresultado360].astype(str).str.strip().isin(listIdsExcluded)]['telefono'].tolist()).apply(len)      .rename('try_by_phone')      .reset_index()      .replace('',np.nan)      .sort_values(by = ['try_by_phone'], ascending = False))
        df_intentos.rename(columns={'index':'telefono'},inplace=True)
        df_intentos['telefono'] = df_intentos['telefono'].astype(str).str.strip()
        df_360['telefono'] = df_360['telefono'].astype(str).replace('.0','').replace('none','').replace('nan','').str.strip()

        df_360 = pd.merge( df_360,df_intentos,
                          how="left",
                          on="telefono")
        df_360['try_by_phone'].fillna(0,inplace=True)
    print('LOG:END try_by_phone')
    ################################################################################################################
    print('LOG:BEGIN try_by_id')
    if not len(df_360[~df_360[keyIdresultado360].astype(str).str.strip().isin(listIdsExcluded)]): df_360['try_by_id'] = 0
    else: 
        df_intentos = (df_360[~df_360[keyIdresultado360].astype(str).str.strip().isin(listIdsExcluded)]
                       .groupby(keysBM)
                       .apply(len)      
                       .rename('try_by_id')      
                       .reset_index()      
                       .replace('',np.nan)      
                       .sort_values(by = ['try_by_id'], ascending = False))
#         df_intentos.rename(columns={'index':keyBM},inplace=True)
        for key in keysBM:
            df_360[key] = df_360[key].astype(str).str.strip()
            df_intentos[key] = df_intentos[key].astype(str).str.strip()
            
        df_360 = pd.merge( df_360,df_intentos,
                          how="left",
                          on=keysBM)
        df_360['try_by_id'].fillna(0,inplace=True)
    print('LOG:END try_by_id')
    ################################################################################################################
    print('LOG:BEGIN count_promises')
    if not len(df_360[df_360[keyIdresultado360].astype(str).str.strip().isin(listIdsPromises)]): df_360['count_promises'] = 0
    else: 
        df_intentos = (df_360[df_360[keyIdresultado360].astype(str).str.strip().isin(listIdsPromises)]
                       .groupby(keysBM)
                       .apply(len)      
                       .rename('count_promises')      
                       .reset_index()      
                       .replace('',np.nan)      
                       .sort_values(by = ['count_promises'], ascending = False))
#         df_intentos.rename(columns={'index':keyBM},inplace=True)
        for key in keysBM:
            df_360[key] = df_360[key].astype(str).str.strip()
            df_intentos[key] = df_intentos[key].astype(str).str.strip()
            
        df_360 = pd.merge( df_360,df_intentos,
                          how="left",
                          on=keysBM)
        df_360['count_promises'].fillna(0,inplace=True)
    print('LOG:END count_promises')
    ################################################################################################################
    print('len(df_360)',len(df_360))
#     print('len(df_360[keysBM].unique())',len(df_360[keysBM].unique()))    
    #CUSTOM FALABELLA
    # df_360[columnsSql360Moments].to_sql(tableMMoments, engine, if_exists='append', index = False,schema=bd_avi_360)
    df_360[df_360.moment.astype(str).str.strip() != ''].groupby(keysBM+['moment','fecha_llamada']).head(1)[columnsSql360Moments].to_sql(tableMMoments, engine, if_exists='append', index = False,schema=bd_avi_360)

    if (isBestManaged):
        print('isBestManaged? :',isBestManaged)
        for key in keysBM:
            df_360[key] = df_360[key].astype(str).str.strip()
        df_360[keyRanking] = df_360[keyRanking].astype(int)
        print('df_360 before:',len(df_360))
        dfBM = df_360.sort_values(keyRanking).groupby(keysBM+[keyIdSegmento]).head(1)
        print('len(dfBM)',len(dfBM))
        print('INICIO TO_SQL '+str(tableBMToday))
        dfBM[columnsSql360].to_sql(tableBMToday, engine, if_exists=ifExistsTables, index = False,schema=bd_avi_360)
        print('FIN TO_SQL '+str(tableBMToday))
        print('INICIO TO_SQL '+str(tableBMTotal))
        dfBM[columnsSql360].to_sql(tableBMTotal, engine, if_exists='append', index = False,schema=bd_avi_360)
        print('FIN TO_SQL '+str(tableBMTotal))

    dfBM.groupby('segmento').count()
    fin_ejecucion(start_date=begin,texto_to_print='END')

    #AHORA SE REQUIERE SACAR LA MEJOR GESTION ACUMULADA DEL MES, REALIZANDO:
    #1- CONSULTA A TABLA MEJOR GESTION TOTAL DONDE EL RANKING SEA EL MENOR Y EL MES SEA EL ACTUAL
    del [[df_360]]
    gc.collect()
    df_360 = consultar_tabla(q360BMTotal,engine,chunk_size=1000000,params=params)
    if not len(df_360) : print('LOG: No hay registros en df_360');#sys.exit()
    for key in keysBM:
        df_360[key] = df_360[key].astype(str).str.strip()

    df_ultima_gestion = df_360.sort_values(['fecha_llamada','hora_llamada'],ascending=False)\
            .groupby(keysBM).head(1)[['last_management']+keysBM]
    print('len(df_360)',len(df_360))
    print('len(df_ultima_gestion)',len(df_ultima_gestion))

    for key in keysBM:
        df_ultima_gestion[key] = df_ultima_gestion[key].astype(str).str.strip()
        
    if ('last_management' in  df_360.columns.values): del df_360['last_management'];
    df_360 = pd.merge( df_360, df_ultima_gestion,
            how='left', on=keysBM)

    print('df_360 before:',len(df_360))
    dfBM = df_360.sort_values(keyRanking).groupby(keysBM+[keyIdSegmento]).head(1)
    print('len(dfBM)',len(dfBM))

    fin_ejecucion(start_date=begin,texto_to_print='END')

    print('INICIO TO_SQL '+str(tableBMMonth))
    dfBM[columnsSql360].to_sql(tableBMMonth, engine, if_exists=ifExistsTables, index = False,schema=bd_avi_360)
    print('FIN TO_SQL '+str(tableBMMonth))

    fin_ejecucion(start_date=begin,texto_to_print='END')

del [[df_360]]
gc.collect()

df_360LastsDates = consultar_tabla(q360BMLastDates,engine,chunk_size=1000,params=params)
listLastsDates = "'" + "','".join((map(str,df_360LastsDates['fecha_llamada'].astype(str).values.tolist()))) + "'"
q360BMLast += " AND fecha_llamada IN ({0})".format(listLastsDates)

df_360 = consultar_tabla(q360BMLast,engine,chunk_size=1000000,params=params)



if not len(df_360) :
    print('LOG: No hay registros en df_360 para last');#sys.exit()
    df_360 = consultar_tabla(q360BMLastDefault,engine,chunk_size=1000000,params=params)
    df_360.fecha_llamada = pd.to_datetime(df_360.fecha_llamada,format='%Y-%m-%d')
    dfBM = df_360.sort_values('fecha_llamada',ascending=False).groupby(keysBM+[keyIdSegmento]).head(1)
    dfBM.fecha_llamada = dfBM.fecha_llamada.astype(str)
else:
    for key in keysBM:
        df_360[key] = df_360[key].astype(str).str.strip()
    df_ultima_gestion = df_360.sort_values(['fecha_llamada','hora_llamada'],ascending=False)\
            .groupby(keysBM).head(1)[['last_management']+keysBM]
    print('len(df_360)',len(df_360))
    print('len(df_ultima_gestion)',len(df_ultima_gestion))

    for key in keysBM:
        df_ultima_gestion[key] = df_ultima_gestion[key].astype(str).str.strip()
    if ('last_management' in  df_360.columns.values): del df_360['last_management'];
    df_360 = pd.merge( df_360, df_ultima_gestion,
            how='left', on=keysBM)

    df_360.fecha_llamada = pd.to_datetime(df_360.fecha_llamada,format='%Y-%m-%d')
    print('df_360 before:',len(df_360))
    dfBM = df_360.sort_values('fecha_llamada',ascending=False).groupby(keysBM+[keyIdSegmento]).head(1)
    print('len(dfBM)',len(dfBM))
    dfBM.fecha_llamada = dfBM.fecha_llamada.astype(str)

    queryCountMoments = """
                        SELECT
                            COUNT(1) AS count,
                            {5},
                            moment
                        FROM 
                            {0}.{1}
                        WHERE
                            id_cliente = {2}
                            AND id_segmento IN ({3})
                            AND id_asignacion IN ({4})
                            AND moment != ''
                        GROUP BY {5},moment""".format(bd_avi_360,tableMMoments,idCliente,idSegmento,idAsignacion, ','.join(keysBM))
    dfCountMoments = consultar_tabla(queryCountMoments,engine,chunk_size=1000000,params=params)

    if len(dfCountMoments) == 0: dfBM['count_moment'] = 0
    columnsPrev = dfBM.columns
    dfBM = pd.merge(dfBM,dfCountMoments,how='left',on=keysBM+['moment'])
    dfBM['count_moment'] = dfBM['count']
    dfBM['count_moment'] = dfBM['count_moment'].fillna(0).astype(int)
    dfBM = dfBM[columnsPrev]

    for col in hoursColumns:
        # dfBM[campo] = dfBM[campo].astype(str).str.strip()
        dfBM[col] = dfBM[col].astype(str).str.split().str[-1].str.rsplit('.').str[0]
        # dfBM[col].fillna('00:00:00',inplace=True)

    print('INICIO TO_SQL '+str(tableBMLast))
    dfBM[columnsSql360].to_sql(tableBMLast, engine, if_exists=ifExistsTables, index = False,schema=bd_avi_360)
    print('FIN TO_SQL '+str(tableBMLast))

if int(isDownloadableLastBM) == 1:
                                     
    # for campo in hoursColumns:
    #     dfBM[campo] = dfBM[campo].astype(str).str.strip()
    
    validateAndCreateFolder(pathDownloadable)
    print('INICIO TO_EXCEL ')
    writer = pd.ExcelWriter(pathDownloadable+fileNameDownloadable,engine='xlsxwriter')
    dfBM[listColumnsDownloadable].to_excel(writer, sheet_name= 'Hoja1',startcol=0, startrow=0, index=False, header=True)
    writer.save()
    print('FIN TO_EXCEL')

fin_ejecucion(start_date=begin,texto_to_print='END')
r.set(name='bestManagement360',value='done')
r.set(name='bestManagement360Log2',value=str(fin_ejecucion(start_date=begin,texto_to_print='END')))